package com.jiayue.ssi.aspectj;

import cn.hutool.core.util.DesensitizedUtil;
import cn.hutool.json.JSONUtil;
import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.jiayue.ssi.annotation.OperateLog;
import com.jiayue.ssi.backenum.AuditAblesEventEnum;
import com.jiayue.ssi.backenum.BusinessStatus;
import com.jiayue.ssi.backenum.HttpMethod;
import com.jiayue.ssi.entity.SysOperLog;
import com.jiayue.ssi.entity.SysPolicy;
import com.jiayue.ssi.entity.SysUser;
import com.jiayue.ssi.factory.OperateLogFactory;
import com.jiayue.ssi.filter.PropertyPreExcludeFilter;
import com.jiayue.ssi.service.SysPolicyService;
import com.jiayue.ssi.util.IPUtils;
import com.jiayue.ssi.util.RyStringUtils;
import com.jiayue.ssi.util.SecurityContextUtil;
import com.jiayue.ssi.util.ServletUtils;
import org.apache.commons.lang3.ArrayUtils;
import org.apache.commons.lang3.StringUtils;
import org.aspectj.lang.JoinPoint;
import org.aspectj.lang.annotation.AfterReturning;
import org.aspectj.lang.annotation.AfterThrowing;
import org.aspectj.lang.annotation.Aspect;
import org.aspectj.lang.annotation.Before;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.core.NamedThreadLocal;
import org.springframework.core.annotation.Order;
import org.springframework.stereotype.Component;
import org.springframework.validation.BindingResult;
import org.springframework.web.multipart.MultipartFile;
import com.alibaba.fastjson2.JSON;

import javax.servlet.ServletRequest;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import java.util.Collection;
import java.util.Enumeration;
import java.util.HashMap;
import java.util.Map;

/**
 * 操作日志记录处理
 *
 * @author ruoyi
 */
@Aspect
@Component
@Order(5)
public class OperateLogAspect {
    private static final Logger log = LoggerFactory.getLogger(OperateLogAspect.class);

    /**
     * 排除敏感属性字段
     */
    public static final String[] EXCLUDE_PROPERTIES = {"password", "oldPassword", "newPassword", "confirmPassword"};

    /**
     * 计算操作消耗时间
     */
    private static final ThreadLocal<Long> TIME_THREADLOCAL = new NamedThreadLocal<Long>("Cost Time");

    @Autowired
    SysPolicyService sysPolicyService;

    /**
     * 处理请求前执行
     */
    @Before(value = "@annotation(controllerLog)")
    public void boBefore(JoinPoint joinPoint, OperateLog controllerLog) {
        TIME_THREADLOCAL.set(System.currentTimeMillis());
    }

    /**
     * 处理完请求后执行
     *
     * @param joinPoint 切点
     */
    @AfterReturning(pointcut = "@annotation(controllerLog)", returning = "jsonResult")
    public void doAfterReturning(JoinPoint joinPoint, OperateLog controllerLog, Object jsonResult) {
        handleLog(joinPoint, controllerLog, null, jsonResult);
    }

    /**
     * 拦截异常操作
     *
     * @param joinPoint 切点
     * @param e         异常
     */
    @AfterThrowing(value = "@annotation(controllerLog)", throwing = "e")
    public void doAfterThrowing(JoinPoint joinPoint, OperateLog controllerLog, Exception e) {
        handleLog(joinPoint, controllerLog, e, null);
    }

    protected void handleLog(final JoinPoint joinPoint, OperateLog controllerLog, final Exception e, Object jsonResult) {
        try {
            String visitUrl = StringUtils.substring(ServletUtils.getRequest().getRequestURI(), 0, 255);
            // 对审计策略配置过滤
            SysPolicy sysPolicy = sysPolicyService.getOne(new QueryWrapper<>());
            String auditableEvent = sysPolicy.getAuditableEvent();

            boolean executeAudit = true;
            if (auditableEvent!=null){
                String[] auditables = auditableEvent.split(",");
                for (int i=0;i<auditables.length;i++){
                    // 0-NWP;1-DQ
                    if (visitUrl.equals(AuditAblesEventEnum.getByCode(Integer.parseInt(auditables[i])).getMessage())){
                        // 遇到短期或者nwp不加入审计
                        executeAudit = false;
                        break;
                    }
                }
            }

            if (executeAudit){
                // 获取当前的用户
                SysUser sysUser = SecurityContextUtil.getSysUser();

                // *========数据库日志=========*//
                SysOperLog operLog = new SysOperLog();
                operLog.setStatus(BusinessStatus.SUCCESS.ordinal());
                // 请求的地址
                String ip = IPUtils.getIpAddr();
                operLog.setOperIp(ip);
                operLog.setOperUrl(visitUrl);
                if (sysUser != null) {
                    operLog.setOperName(sysUser.getUsername());
                }

                if (e != null) {
                    operLog.setStatus(BusinessStatus.FAIL.ordinal());
                    operLog.setErrorMsg(StringUtils.substring(e.getMessage(), 0, 2000));
                }
                // 设置方法名称
                String className = joinPoint.getTarget().getClass().getName();
                String methodName = joinPoint.getSignature().getName();
                operLog.setMethod(className + "." + methodName + "()");
                // 设置请求方式
                operLog.setRequestMethod(ServletUtils.getRequest().getMethod());
                // 处理设置注解上的参数
                getControllerMethodDescription(joinPoint, controllerLog, operLog, jsonResult);
                // 设置消耗时间
                operLog.setCostTime(System.currentTimeMillis() - TIME_THREADLOCAL.get());
                operLog.setCreateBy(sysUser.getUsername());
                // 保存数据库
                OperateLogFactory.recordOper(operLog);
            }
        } catch (Exception exp) {
            // 记录本地异常日志
            log.error("异常信息:{}", exp.getMessage());
            exp.printStackTrace();
        } finally {
            TIME_THREADLOCAL.remove();
        }
    }

    /**
     * 获取注解中对方法的描述信息 用于Controller层注解
     *
     * @param log     日志
     * @param operLog 操作日志
     * @throws Exception
     */
    public void getControllerMethodDescription(JoinPoint joinPoint, OperateLog log, SysOperLog operLog, Object jsonResult) throws Exception {
        // 设置action动作
        operLog.setBusinessType(log.businessType().ordinal());
        // 设置标题
        operLog.setTitle(log.title());
        // 操作描述
        operLog.setOperdesc(log.operdesc());
        // 审计类型
        operLog.setAuditType(log.auditType().ordinal());
        // 设置操作人类别
        operLog.setOperatorType(log.operatorType().ordinal());
        // 是否需要保存request，参数和值
        if (log.isSaveRequestData()) {
            // 获取参数的信息，传入到数据库中。
            setRequestValue(joinPoint, operLog, log.excludeParamNames());
        }
        // 是否需要保存response，参数和值
//        if (log.isSaveResponseData() && RyStringUtils.isNotNull(jsonResult)) {
//            operLog.setJsonResult(RyStringUtils.substring(JSON.toJSONString(jsonResult), 0, 2000));
//        }
    }

    /**
     * 获取请求的参数，放到log中
     *
     * @param operLog 操作日志
     * @throws Exception 异常
     */
    private void setRequestValue(JoinPoint joinPoint, SysOperLog operLog, String[] excludeParamNames) throws Exception {
        String requestMethod = operLog.getRequestMethod();
        if (HttpMethod.PUT.name().equals(requestMethod) || HttpMethod.POST.name().equals(requestMethod)|| HttpMethod.DELETE.name().equals(requestMethod)) {
            String params = argsArrayToString(joinPoint.getArgs(), excludeParamNames,ServletUtils.getRequest());
            operLog.setOperParam(StringUtils.substring(params, 0, 2000));
        } else {
            Map<?, ?> paramsMap = ServletUtils.getParamMap(ServletUtils.getRequest());
            operLog.setOperParam(StringUtils.substring(JSON.toJSONString(paramsMap, excludePropertyPreFilter(excludeParamNames)), 0, 2000));
        }
    }

    /**
     * 参数拼装
     */
    private String argsArrayToString(Object[] paramsArray, String[] excludeParamNames, ServletRequest request) {
        Map<String,String> map = new HashMap<>(16);
        Enumeration enumeration=request.getParameterNames();
        while(enumeration.hasMoreElements()){
            String name=(String)enumeration.nextElement();//得到name的名字。
//            System.out.print("属性"+name);
            String value=request.getParameter(name);//是通过页面中的name属性得到值。
//            System.out.println(",值："+value);

            // 脱敏处理
            if ("mailbox".equals(name)){
                value = DesensitizedUtil.email(value);
            }
            else if ("nickname".equals(name)){
                // 姓名
                value = DesensitizedUtil.chineseName(value);
            }
            else if ("phonenumber".equals(name)){
                // 手机号
                value = DesensitizedUtil.mobilePhone(value);
            }
            else if ("againPwd".equals(name) || "oldPassword".equals(name) || "newPassword".equals(name) || "confirmPassword".equals(name)|| "bakPassword".equals(name)|| "checkPassword".equals(name)){
                // 密码
                value = DesensitizedUtil.password(value);
            }
            else if ("idcard".equals(name)){
                // 身份证
                value = DesensitizedUtil.idCardNum(value,5,2);
            }

            map.put(name,value);
        }
        return JSONUtil.parseObj(map).toString();
//        String params = "";
//        if (paramsArray != null && paramsArray.length > 0) {
//            for (Object o : paramsArray) {
//                if (RyStringUtils.isNotNull(o) && !isFilterObject(o)) {
//                    try {
//                        String jsonObj = JSON.toJSONString(o, excludePropertyPreFilter(excludeParamNames));
//                        params += jsonObj.toString() + " ";
//                    } catch (Exception e) {
//                    }
//                }
//            }
//        }
//        return params.trim();
    }

    /**
     * 忽略敏感属性
     */
    public PropertyPreExcludeFilter excludePropertyPreFilter(String[] excludeParamNames) {
        return new PropertyPreExcludeFilter().addExcludes(ArrayUtils.addAll(EXCLUDE_PROPERTIES, excludeParamNames));
    }

    /**
     * 判断是否需要过滤的对象。
     *
     * @param o 对象信息。
     * @return 如果是需要过滤的对象，则返回true；否则返回false。
     */
    @SuppressWarnings("rawtypes")
    public boolean isFilterObject(final Object o) {
        Class<?> clazz = o.getClass();
        if (clazz.isArray()) {
            return clazz.getComponentType().isAssignableFrom(MultipartFile.class);
        } else if (Collection.class.isAssignableFrom(clazz)) {
            Collection collection = (Collection) o;
            for (Object value : collection) {
                return value instanceof MultipartFile;
            }
        } else if (Map.class.isAssignableFrom(clazz)) {
            Map map = (Map) o;
            for (Object value : map.entrySet()) {
                Map.Entry entry = (Map.Entry) value;
                return entry.getValue() instanceof MultipartFile;
            }
        }
        return o instanceof MultipartFile || o instanceof HttpServletRequest || o instanceof HttpServletResponse
                || o instanceof BindingResult;
    }
}
